/**
 * Ein Abschluss eines allgemeinen Binrbaums.
 * 
 * @author Bernd Gramlich
 * @version 2012-12-20
 */
public class Abschluss extends Baumelement
{
    /**
     * Konstruktor.
     * Der Abschluss der Baums enthlt nichts.
     * Deshalb braucht auch nichts getan zu werden.
     */
    public Abschluss ()
    {
    }

    /**
     * Nenne meinen linken Nachfolger.
     * Mein linker Nachfolger ist null, da ich ein
     * Abschluss des Baums bin.
     */
    public Baumelement gibLinkenNachfolger ()
    {
        return null;
    }

    /**
     * Nenne meinen rechten Nachfolger.
     * Mein rechter Nachfolger ist null, da ich ein
     * Abschluss des Baums bin.
     */
    public Baumelement gibRechtenNachfolger ()
    {
        return null;
    }

    /**
     * Nenne meinen Inhalt.
     * Mein Inhalt ist null, da ich ein
     * Abschluss des Baums bin.
     */
    public Eintrag gibInhalt ()
    {
        return null;
    }

    /**
     * Fge einen neuen Eintrag aufsteigend sortiert in den Baum ein.
     * 
     * Da ich der Abschluss bin, erzeuge ich einen neuen
     * Knoten mit mir als linkem Nachfolger und einem neuen Abschluss
     * als rechtem Nachfolger. Den Verweis auf mich selbst erziele ich
     * durch das Java-Schlsselwort "this".
     */
    public Baumelement fuegePassendEin (Eintrag neuerEintrag, String baumposition)
    {
        return new Knoten (this, new Abschluss (), neuerEintrag, baumposition);
    }

    /**
     * Drucke den Inhalt des Binrbaums ab mir selbst in
     * aufsteigender Reihenfolge auf die Konsole.
     */
    public void druckeInOrder ()
    {
    }

    /**
     * Drucke den Inhalt des Binrbaums ab mir selbst in
     * Prordnung auf die Konsole.
     */
    public void druckePreOrder ()
    {
    }

    /**
     * Drucke den Inhalt des Binrbaums ab mir selbst in
     * Postordnung auf die Konsole.
     */
    public void druckePostOrder ()
    {
    }

    /**
     * Zhle, wie viele Knoten ab mir selbst die "eigenschaft" haben.
     */
    public int zaehle (Eigenschaft eigenschaft)
    {
        return 0;
    }

    /**
     * Fhre fr alle Knoten ab mir selbst, die die Eigenschaft
     * "eigenschaft" haben, den Befehl "befehl" mit den Argumenten
     * "zeichenkette" aus.
     */
    public void fuehreAusFuer (Eigenschaft eigenschaft, Befehl befehl, String[] zeichenkette)
    {
    }

    /**
     * Suche einen Eintrag ab mir im Baum (in order), der zum Suchwort passt.
     */
    public Eintrag suche (String suchwort)
    {
        return null;
    } 

    /**
     * Lsche den ersten Knoten ab mir im Baum, der zum Suchwort passt.
     * 
     * Es gibt keinen solchen Eintrag, da ich ein Abschluss bin. Also
     * bleibt der Baum unverndert.
     */
    public Baumelement loesche (String suchwort, String baumposition)
    {
        return this;
    }

    /**
     * Nenne den grten Eintrag ab mir im Baum.
     */
    public Eintrag gibMaximum ()
    {
        return null;
    }

    /**
     * Lsche den grten Knoten ab mir im Baum.
     */
    public Baumelement loescheMaximum ()
    {
        return this;
    }

    /**
     * Zeichne den Baum ab mir neu.
     */
    public void zeichneNeu (String baumposition)
    {
    }
}
